<?php

namespace ArtabanMarketplace\Model\Base;

use \Exception;
use \PDO;
use ArtabanMarketplace\Model\AmpSellerAdmin as ChildAmpSellerAdmin;
use ArtabanMarketplace\Model\AmpSellerAdminQuery as ChildAmpSellerAdminQuery;
use ArtabanMarketplace\Model\Map\AmpSellerAdminTableMap;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\ModelCriteria;
use Propel\Runtime\ActiveQuery\ModelJoin;
use Propel\Runtime\Collection\Collection;
use Propel\Runtime\Collection\ObjectCollection;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\Exception\PropelException;
use Thelia\Model\Admin;

/**
 * Base class that represents a query for the 'amp_seller_admin' table.
 *
 *
 *
 * @method     ChildAmpSellerAdminQuery orderById($order = Criteria::ASC) Order by the id column
 * @method     ChildAmpSellerAdminQuery orderByAmpSellerId($order = Criteria::ASC) Order by the amp_seller_id column
 * @method     ChildAmpSellerAdminQuery orderByAdminId($order = Criteria::ASC) Order by the admin_id column
 * @method     ChildAmpSellerAdminQuery orderByCreatedAt($order = Criteria::ASC) Order by the created_at column
 * @method     ChildAmpSellerAdminQuery orderByUpdatedAt($order = Criteria::ASC) Order by the updated_at column
 * @method     ChildAmpSellerAdminQuery orderByVersion($order = Criteria::ASC) Order by the version column
 * @method     ChildAmpSellerAdminQuery orderByVersionCreatedAt($order = Criteria::ASC) Order by the version_created_at column
 * @method     ChildAmpSellerAdminQuery orderByVersionCreatedBy($order = Criteria::ASC) Order by the version_created_by column
 *
 * @method     ChildAmpSellerAdminQuery groupById() Group by the id column
 * @method     ChildAmpSellerAdminQuery groupByAmpSellerId() Group by the amp_seller_id column
 * @method     ChildAmpSellerAdminQuery groupByAdminId() Group by the admin_id column
 * @method     ChildAmpSellerAdminQuery groupByCreatedAt() Group by the created_at column
 * @method     ChildAmpSellerAdminQuery groupByUpdatedAt() Group by the updated_at column
 * @method     ChildAmpSellerAdminQuery groupByVersion() Group by the version column
 * @method     ChildAmpSellerAdminQuery groupByVersionCreatedAt() Group by the version_created_at column
 * @method     ChildAmpSellerAdminQuery groupByVersionCreatedBy() Group by the version_created_by column
 *
 * @method     ChildAmpSellerAdminQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method     ChildAmpSellerAdminQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method     ChildAmpSellerAdminQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method     ChildAmpSellerAdminQuery leftJoinAmpSeller($relationAlias = null) Adds a LEFT JOIN clause to the query using the AmpSeller relation
 * @method     ChildAmpSellerAdminQuery rightJoinAmpSeller($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AmpSeller relation
 * @method     ChildAmpSellerAdminQuery innerJoinAmpSeller($relationAlias = null) Adds a INNER JOIN clause to the query using the AmpSeller relation
 *
 * @method     ChildAmpSellerAdminQuery leftJoinAdmin($relationAlias = null) Adds a LEFT JOIN clause to the query using the Admin relation
 * @method     ChildAmpSellerAdminQuery rightJoinAdmin($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Admin relation
 * @method     ChildAmpSellerAdminQuery innerJoinAdmin($relationAlias = null) Adds a INNER JOIN clause to the query using the Admin relation
 *
 * @method     ChildAmpSellerAdminQuery leftJoinAmpSellerAdminVersion($relationAlias = null) Adds a LEFT JOIN clause to the query using the AmpSellerAdminVersion relation
 * @method     ChildAmpSellerAdminQuery rightJoinAmpSellerAdminVersion($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AmpSellerAdminVersion relation
 * @method     ChildAmpSellerAdminQuery innerJoinAmpSellerAdminVersion($relationAlias = null) Adds a INNER JOIN clause to the query using the AmpSellerAdminVersion relation
 *
 * @method     ChildAmpSellerAdmin findOne(ConnectionInterface $con = null) Return the first ChildAmpSellerAdmin matching the query
 * @method     ChildAmpSellerAdmin findOneOrCreate(ConnectionInterface $con = null) Return the first ChildAmpSellerAdmin matching the query, or a new ChildAmpSellerAdmin object populated from the query conditions when no match is found
 *
 * @method     ChildAmpSellerAdmin findOneById(int $id) Return the first ChildAmpSellerAdmin filtered by the id column
 * @method     ChildAmpSellerAdmin findOneByAmpSellerId(int $amp_seller_id) Return the first ChildAmpSellerAdmin filtered by the amp_seller_id column
 * @method     ChildAmpSellerAdmin findOneByAdminId(int $admin_id) Return the first ChildAmpSellerAdmin filtered by the admin_id column
 * @method     ChildAmpSellerAdmin findOneByCreatedAt(string $created_at) Return the first ChildAmpSellerAdmin filtered by the created_at column
 * @method     ChildAmpSellerAdmin findOneByUpdatedAt(string $updated_at) Return the first ChildAmpSellerAdmin filtered by the updated_at column
 * @method     ChildAmpSellerAdmin findOneByVersion(int $version) Return the first ChildAmpSellerAdmin filtered by the version column
 * @method     ChildAmpSellerAdmin findOneByVersionCreatedAt(string $version_created_at) Return the first ChildAmpSellerAdmin filtered by the version_created_at column
 * @method     ChildAmpSellerAdmin findOneByVersionCreatedBy(string $version_created_by) Return the first ChildAmpSellerAdmin filtered by the version_created_by column
 *
 * @method     array findById(int $id) Return ChildAmpSellerAdmin objects filtered by the id column
 * @method     array findByAmpSellerId(int $amp_seller_id) Return ChildAmpSellerAdmin objects filtered by the amp_seller_id column
 * @method     array findByAdminId(int $admin_id) Return ChildAmpSellerAdmin objects filtered by the admin_id column
 * @method     array findByCreatedAt(string $created_at) Return ChildAmpSellerAdmin objects filtered by the created_at column
 * @method     array findByUpdatedAt(string $updated_at) Return ChildAmpSellerAdmin objects filtered by the updated_at column
 * @method     array findByVersion(int $version) Return ChildAmpSellerAdmin objects filtered by the version column
 * @method     array findByVersionCreatedAt(string $version_created_at) Return ChildAmpSellerAdmin objects filtered by the version_created_at column
 * @method     array findByVersionCreatedBy(string $version_created_by) Return ChildAmpSellerAdmin objects filtered by the version_created_by column
 *
 */
abstract class AmpSellerAdminQuery extends ModelCriteria
{

    // versionable behavior

    /**
     * Whether the versioning is enabled
     */
    static $isVersioningEnabled = true;

    /**
     * Initializes internal state of \ArtabanMarketplace\Model\Base\AmpSellerAdminQuery object.
     *
     * @param     string $dbName The database name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = 'thelia', $modelName = '\\ArtabanMarketplace\\Model\\AmpSellerAdmin', $modelAlias = null)
    {
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new ChildAmpSellerAdminQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param     Criteria $criteria Optional Criteria to build the query from
     *
     * @return ChildAmpSellerAdminQuery
     */
    public static function create($modelAlias = null, $criteria = null)
    {
        if ($criteria instanceof \ArtabanMarketplace\Model\AmpSellerAdminQuery) {
            return $criteria;
        }
        $query = new \ArtabanMarketplace\Model\AmpSellerAdminQuery();
        if (null !== $modelAlias) {
            $query->setModelAlias($modelAlias);
        }
        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param ConnectionInterface $con an optional connection object
     *
     * @return ChildAmpSellerAdmin|array|mixed the result, formatted by the current formatter
     */
    public function findPk($key, $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = AmpSellerAdminTableMap::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getServiceContainer()->getReadConnection(AmpSellerAdminTableMap::DATABASE_NAME);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     ConnectionInterface $con A connection object
     *
     * @return   ChildAmpSellerAdmin A model object, or null if the key is not found
     */
    protected function findPkSimple($key, $con)
    {
        $sql = 'SELECT ID, AMP_SELLER_ID, ADMIN_ID, CREATED_AT, UPDATED_AT, VERSION, VERSION_CREATED_AT, VERSION_CREATED_BY FROM amp_seller_admin WHERE ID = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), 0, $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(\PDO::FETCH_NUM)) {
            $obj = new ChildAmpSellerAdmin();
            $obj->hydrate($row);
            AmpSellerAdminTableMap::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     ConnectionInterface $con A connection object
     *
     * @return ChildAmpSellerAdmin|array|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($dataFetcher);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     ConnectionInterface $con an optional connection object
     *
     * @return ObjectCollection|array|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getReadConnection($this->getDbName());
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($dataFetcher);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(AmpSellerAdminTableMap::ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(AmpSellerAdminTableMap::ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id > 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(AmpSellerAdminTableMap::ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(AmpSellerAdminTableMap::ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerAdminTableMap::ID, $id, $comparison);
    }

    /**
     * Filter the query on the amp_seller_id column
     *
     * Example usage:
     * <code>
     * $query->filterByAmpSellerId(1234); // WHERE amp_seller_id = 1234
     * $query->filterByAmpSellerId(array(12, 34)); // WHERE amp_seller_id IN (12, 34)
     * $query->filterByAmpSellerId(array('min' => 12)); // WHERE amp_seller_id > 12
     * </code>
     *
     * @see       filterByAmpSeller()
     *
     * @param     mixed $ampSellerId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function filterByAmpSellerId($ampSellerId = null, $comparison = null)
    {
        if (is_array($ampSellerId)) {
            $useMinMax = false;
            if (isset($ampSellerId['min'])) {
                $this->addUsingAlias(AmpSellerAdminTableMap::AMP_SELLER_ID, $ampSellerId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($ampSellerId['max'])) {
                $this->addUsingAlias(AmpSellerAdminTableMap::AMP_SELLER_ID, $ampSellerId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerAdminTableMap::AMP_SELLER_ID, $ampSellerId, $comparison);
    }

    /**
     * Filter the query on the admin_id column
     *
     * Example usage:
     * <code>
     * $query->filterByAdminId(1234); // WHERE admin_id = 1234
     * $query->filterByAdminId(array(12, 34)); // WHERE admin_id IN (12, 34)
     * $query->filterByAdminId(array('min' => 12)); // WHERE admin_id > 12
     * </code>
     *
     * @see       filterByAdmin()
     *
     * @param     mixed $adminId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function filterByAdminId($adminId = null, $comparison = null)
    {
        if (is_array($adminId)) {
            $useMinMax = false;
            if (isset($adminId['min'])) {
                $this->addUsingAlias(AmpSellerAdminTableMap::ADMIN_ID, $adminId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($adminId['max'])) {
                $this->addUsingAlias(AmpSellerAdminTableMap::ADMIN_ID, $adminId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerAdminTableMap::ADMIN_ID, $adminId, $comparison);
    }

    /**
     * Filter the query on the created_at column
     *
     * Example usage:
     * <code>
     * $query->filterByCreatedAt('2011-03-14'); // WHERE created_at = '2011-03-14'
     * $query->filterByCreatedAt('now'); // WHERE created_at = '2011-03-14'
     * $query->filterByCreatedAt(array('max' => 'yesterday')); // WHERE created_at > '2011-03-13'
     * </code>
     *
     * @param     mixed $createdAt The value to use as filter.
     *              Values can be integers (unix timestamps), DateTime objects, or strings.
     *              Empty strings are treated as NULL.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function filterByCreatedAt($createdAt = null, $comparison = null)
    {
        if (is_array($createdAt)) {
            $useMinMax = false;
            if (isset($createdAt['min'])) {
                $this->addUsingAlias(AmpSellerAdminTableMap::CREATED_AT, $createdAt['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($createdAt['max'])) {
                $this->addUsingAlias(AmpSellerAdminTableMap::CREATED_AT, $createdAt['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerAdminTableMap::CREATED_AT, $createdAt, $comparison);
    }

    /**
     * Filter the query on the updated_at column
     *
     * Example usage:
     * <code>
     * $query->filterByUpdatedAt('2011-03-14'); // WHERE updated_at = '2011-03-14'
     * $query->filterByUpdatedAt('now'); // WHERE updated_at = '2011-03-14'
     * $query->filterByUpdatedAt(array('max' => 'yesterday')); // WHERE updated_at > '2011-03-13'
     * </code>
     *
     * @param     mixed $updatedAt The value to use as filter.
     *              Values can be integers (unix timestamps), DateTime objects, or strings.
     *              Empty strings are treated as NULL.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function filterByUpdatedAt($updatedAt = null, $comparison = null)
    {
        if (is_array($updatedAt)) {
            $useMinMax = false;
            if (isset($updatedAt['min'])) {
                $this->addUsingAlias(AmpSellerAdminTableMap::UPDATED_AT, $updatedAt['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($updatedAt['max'])) {
                $this->addUsingAlias(AmpSellerAdminTableMap::UPDATED_AT, $updatedAt['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerAdminTableMap::UPDATED_AT, $updatedAt, $comparison);
    }

    /**
     * Filter the query on the version column
     *
     * Example usage:
     * <code>
     * $query->filterByVersion(1234); // WHERE version = 1234
     * $query->filterByVersion(array(12, 34)); // WHERE version IN (12, 34)
     * $query->filterByVersion(array('min' => 12)); // WHERE version > 12
     * </code>
     *
     * @param     mixed $version The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function filterByVersion($version = null, $comparison = null)
    {
        if (is_array($version)) {
            $useMinMax = false;
            if (isset($version['min'])) {
                $this->addUsingAlias(AmpSellerAdminTableMap::VERSION, $version['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($version['max'])) {
                $this->addUsingAlias(AmpSellerAdminTableMap::VERSION, $version['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerAdminTableMap::VERSION, $version, $comparison);
    }

    /**
     * Filter the query on the version_created_at column
     *
     * Example usage:
     * <code>
     * $query->filterByVersionCreatedAt('2011-03-14'); // WHERE version_created_at = '2011-03-14'
     * $query->filterByVersionCreatedAt('now'); // WHERE version_created_at = '2011-03-14'
     * $query->filterByVersionCreatedAt(array('max' => 'yesterday')); // WHERE version_created_at > '2011-03-13'
     * </code>
     *
     * @param     mixed $versionCreatedAt The value to use as filter.
     *              Values can be integers (unix timestamps), DateTime objects, or strings.
     *              Empty strings are treated as NULL.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function filterByVersionCreatedAt($versionCreatedAt = null, $comparison = null)
    {
        if (is_array($versionCreatedAt)) {
            $useMinMax = false;
            if (isset($versionCreatedAt['min'])) {
                $this->addUsingAlias(AmpSellerAdminTableMap::VERSION_CREATED_AT, $versionCreatedAt['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($versionCreatedAt['max'])) {
                $this->addUsingAlias(AmpSellerAdminTableMap::VERSION_CREATED_AT, $versionCreatedAt['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerAdminTableMap::VERSION_CREATED_AT, $versionCreatedAt, $comparison);
    }

    /**
     * Filter the query on the version_created_by column
     *
     * Example usage:
     * <code>
     * $query->filterByVersionCreatedBy('fooValue');   // WHERE version_created_by = 'fooValue'
     * $query->filterByVersionCreatedBy('%fooValue%'); // WHERE version_created_by LIKE '%fooValue%'
     * </code>
     *
     * @param     string $versionCreatedBy The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function filterByVersionCreatedBy($versionCreatedBy = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($versionCreatedBy)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $versionCreatedBy)) {
                $versionCreatedBy = str_replace('*', '%', $versionCreatedBy);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(AmpSellerAdminTableMap::VERSION_CREATED_BY, $versionCreatedBy, $comparison);
    }

    /**
     * Filter the query by a related \ArtabanMarketplace\Model\AmpSeller object
     *
     * @param \ArtabanMarketplace\Model\AmpSeller|ObjectCollection $ampSeller The related object(s) to use as filter
     * @param string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function filterByAmpSeller($ampSeller, $comparison = null)
    {
        if ($ampSeller instanceof \ArtabanMarketplace\Model\AmpSeller) {
            return $this
                ->addUsingAlias(AmpSellerAdminTableMap::AMP_SELLER_ID, $ampSeller->getId(), $comparison);
        } elseif ($ampSeller instanceof ObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(AmpSellerAdminTableMap::AMP_SELLER_ID, $ampSeller->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAmpSeller() only accepts arguments of type \ArtabanMarketplace\Model\AmpSeller or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AmpSeller relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function joinAmpSeller($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AmpSeller');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AmpSeller');
        }

        return $this;
    }

    /**
     * Use the AmpSeller relation AmpSeller object
     *
     * @see useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerQuery A secondary query class using the current class as primary query
     */
    public function useAmpSellerQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAmpSeller($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AmpSeller', '\ArtabanMarketplace\Model\AmpSellerQuery');
    }

    /**
     * Filter the query by a related \Thelia\Model\Admin object
     *
     * @param \Thelia\Model\Admin|ObjectCollection $admin The related object(s) to use as filter
     * @param string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function filterByAdmin($admin, $comparison = null)
    {
        if ($admin instanceof \Thelia\Model\Admin) {
            return $this
                ->addUsingAlias(AmpSellerAdminTableMap::ADMIN_ID, $admin->getId(), $comparison);
        } elseif ($admin instanceof ObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(AmpSellerAdminTableMap::ADMIN_ID, $admin->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAdmin() only accepts arguments of type \Thelia\Model\Admin or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Admin relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function joinAdmin($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Admin');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Admin');
        }

        return $this;
    }

    /**
     * Use the Admin relation Admin object
     *
     * @see useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   \Thelia\Model\AdminQuery A secondary query class using the current class as primary query
     */
    public function useAdminQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAdmin($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Admin', '\Thelia\Model\AdminQuery');
    }

    /**
     * Filter the query by a related \ArtabanMarketplace\Model\AmpSellerAdminVersion object
     *
     * @param \ArtabanMarketplace\Model\AmpSellerAdminVersion|ObjectCollection $ampSellerAdminVersion  the related object to use as filter
     * @param string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function filterByAmpSellerAdminVersion($ampSellerAdminVersion, $comparison = null)
    {
        if ($ampSellerAdminVersion instanceof \ArtabanMarketplace\Model\AmpSellerAdminVersion) {
            return $this
                ->addUsingAlias(AmpSellerAdminTableMap::ID, $ampSellerAdminVersion->getId(), $comparison);
        } elseif ($ampSellerAdminVersion instanceof ObjectCollection) {
            return $this
                ->useAmpSellerAdminVersionQuery()
                ->filterByPrimaryKeys($ampSellerAdminVersion->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByAmpSellerAdminVersion() only accepts arguments of type \ArtabanMarketplace\Model\AmpSellerAdminVersion or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AmpSellerAdminVersion relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function joinAmpSellerAdminVersion($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AmpSellerAdminVersion');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AmpSellerAdminVersion');
        }

        return $this;
    }

    /**
     * Use the AmpSellerAdminVersion relation AmpSellerAdminVersion object
     *
     * @see useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerAdminVersionQuery A secondary query class using the current class as primary query
     */
    public function useAmpSellerAdminVersionQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAmpSellerAdminVersion($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AmpSellerAdminVersion', '\ArtabanMarketplace\Model\AmpSellerAdminVersionQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   ChildAmpSellerAdmin $ampSellerAdmin Object to remove from the list of results
     *
     * @return ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function prune($ampSellerAdmin = null)
    {
        if ($ampSellerAdmin) {
            $this->addUsingAlias(AmpSellerAdminTableMap::ID, $ampSellerAdmin->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

    /**
     * Deletes all rows from the amp_seller_admin table.
     *
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).
     */
    public function doDeleteAll(ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerAdminTableMap::DATABASE_NAME);
        }
        $affectedRows = 0; // initialize var to track total num of affected rows
        try {
            // use transaction because $criteria could contain info
            // for more than one table or we could emulating ON DELETE CASCADE, etc.
            $con->beginTransaction();
            $affectedRows += parent::doDeleteAll($con);
            // Because this db requires some delete cascade/set null emulation, we have to
            // clear the cached instance *after* the emulation has happened (since
            // instances get re-added by the select statement contained therein).
            AmpSellerAdminTableMap::clearInstancePool();
            AmpSellerAdminTableMap::clearRelatedInstancePool();

            $con->commit();
        } catch (PropelException $e) {
            $con->rollBack();
            throw $e;
        }

        return $affectedRows;
    }

    /**
     * Performs a DELETE on the database, given a ChildAmpSellerAdmin or Criteria object OR a primary key value.
     *
     * @param mixed               $values Criteria or ChildAmpSellerAdmin object or primary key or array of primary keys
     *              which is used to create the DELETE statement
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     *                if supported by native driver or if emulated using Propel.
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
     public function delete(ConnectionInterface $con = null)
     {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerAdminTableMap::DATABASE_NAME);
        }

        $criteria = $this;

        // Set the correct dbName
        $criteria->setDbName(AmpSellerAdminTableMap::DATABASE_NAME);

        $affectedRows = 0; // initialize var to track total num of affected rows

        try {
            // use transaction because $criteria could contain info
            // for more than one table or we could emulating ON DELETE CASCADE, etc.
            $con->beginTransaction();


        AmpSellerAdminTableMap::removeInstanceFromPool($criteria);

            $affectedRows += ModelCriteria::delete($con);
            AmpSellerAdminTableMap::clearRelatedInstancePool();
            $con->commit();

            return $affectedRows;
        } catch (PropelException $e) {
            $con->rollBack();
            throw $e;
        }
    }

    // timestampable behavior

    /**
     * Filter by the latest updated
     *
     * @param      int $nbDays Maximum age of the latest update in days
     *
     * @return     ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function recentlyUpdated($nbDays = 7)
    {
        return $this->addUsingAlias(AmpSellerAdminTableMap::UPDATED_AT, time() - $nbDays * 24 * 60 * 60, Criteria::GREATER_EQUAL);
    }

    /**
     * Filter by the latest created
     *
     * @param      int $nbDays Maximum age of in days
     *
     * @return     ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function recentlyCreated($nbDays = 7)
    {
        return $this->addUsingAlias(AmpSellerAdminTableMap::CREATED_AT, time() - $nbDays * 24 * 60 * 60, Criteria::GREATER_EQUAL);
    }

    /**
     * Order by update date desc
     *
     * @return     ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function lastUpdatedFirst()
    {
        return $this->addDescendingOrderByColumn(AmpSellerAdminTableMap::UPDATED_AT);
    }

    /**
     * Order by update date asc
     *
     * @return     ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function firstUpdatedFirst()
    {
        return $this->addAscendingOrderByColumn(AmpSellerAdminTableMap::UPDATED_AT);
    }

    /**
     * Order by create date desc
     *
     * @return     ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function lastCreatedFirst()
    {
        return $this->addDescendingOrderByColumn(AmpSellerAdminTableMap::CREATED_AT);
    }

    /**
     * Order by create date asc
     *
     * @return     ChildAmpSellerAdminQuery The current query, for fluid interface
     */
    public function firstCreatedFirst()
    {
        return $this->addAscendingOrderByColumn(AmpSellerAdminTableMap::CREATED_AT);
    }

    // versionable behavior

    /**
     * Checks whether versioning is enabled
     *
     * @return boolean
     */
    static public function isVersioningEnabled()
    {
        return self::$isVersioningEnabled;
    }

    /**
     * Enables versioning
     */
    static public function enableVersioning()
    {
        self::$isVersioningEnabled = true;
    }

    /**
     * Disables versioning
     */
    static public function disableVersioning()
    {
        self::$isVersioningEnabled = false;
    }

} // AmpSellerAdminQuery
